Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | Static Public Member Functions | List of all members
stk::Socket Class Referenceabstract

STK internet socket abstract base class. More...

`#include <Socket.h>`

Inheritance diagram for stk::Socket:

## Public Member Functions
| Socket ()
| Class constructor.
virtual | ~Socket ()
| Class destructor.
int | id (void) const
| Return the socket descriptor.
int | port (void) const
| Return the socket port number.
virtual int | writeBuffer (const void *buffer, long bufferSize, int flags=0)=0
| Write a buffer over the socket connection. Returns the number of bytes written or -1 if an error occurs.
virtual int | readBuffer (void *buffer, long bufferSize, int flags=0)=0
| Read an input buffer, up to length bufferSize. Returns the number of bytes read or -1 if an error occurs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Static Public Member Functions
static void | close (int socket)
| Close the socket.
static bool | isValid (int socket)
| Returns true if the socket descriptor is valid.
static void | setBlocking (int socket, bool enable)
| If enable = false, the socket is set to non-blocking mode. When first created, sockets are by default in blocking mode.
static int | writeBuffer (int socket, const void *buffer, long bufferSize, int flags)
| Write a buffer via the specified socket. Returns the number of bytes written or -1 if an error occurs.
static int | readBuffer (int socket, void *buffer, long bufferSize, int flags)
| Read a buffer via the specified socket. Returns the number of bytes read or -1 if an error occurs.
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.

## Additional Inherited Members
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK internet socket abstract base class.

This class provides common functionality for TCP and UDP internet socket server and client subclasses. This class also provides a number of static functions for use with external socket descriptors.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

The documentation for this class was generated from the following file:

- Socket.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.